/* Copyright (c) 2000-2003 ActiveState Corp.
   See the file LICENSE.txt for licensing information. */

/* Komodo's Help->About dialog */

var log = getLoggingMgr().getLogger("about");

//---- interface routines for XUL

function OnLoad()
{
    var infoSvc = Components.classes["@activestate.com/koInfoService;1"].
                  getService(Components.interfaces.koIInfoService);

    // Display the correct image.
    aboutImage = document.getElementById("about-image");
    if (infoSvc.version.match(/alpha/)) {
        aboutImage.setAttribute("src",
            "chrome://jaguar/skin/images/about_alpha.png");
    } else if (infoSvc.version.match(/beta/)) {
        aboutImage.setAttribute("src",
            "chrome://jaguar/skin/images/about_beta.png");
    } else if (infoSvc.productType == "professional") {
        aboutImage.setAttribute("src",
            "chrome://jaguar/skin/images/about_professional.png");
    } else if (infoSvc.productType == "personal") {
        aboutImage.setAttribute("src",
            "chrome://jaguar/skin/images/about_personal.png");
    } else {
        log.error("Unexpected product type: '" + infoSvc.productType + "'");
    }

    // Fill in Komodo License information.
    var licenseInfoWidget = document.getElementById("license-info");
    licenseInfoWidget.setAttribute("value", infoSvc.licenseInfo);

    // Fill in Komodo build information.
    var buildInfoWidget = document.getElementById("build-info");
    var buildInfo = "Komodo " + infoSvc.productType +
                    ", version " + infoSvc.version +
                    ", build " + infoSvc.buildNumber +
                    ", platform " + infoSvc.buildPlatform +
                    ".\nBuilt on " + infoSvc.buildASCTime + ".";
    var brandingPhrase = infoSvc.brandingPhrase;
    if (brandingPhrase) {
        buildInfo += "\n"+brandingPhrase;
    }
    buildInfoWidget.value = buildInfo;

    // Give the Ok button the focus, otherwise the textbox might eat <Enter>.
    var dialog = document.getElementById("dialog-about");
    var okButton = dialog.getButton("accept");
    okButton.setAttribute("accesskey", "o");
    okButton.focus();

    window.sizeToContent();
    dialog.moveToAlertPosition();
}


