/* Copyright (c) 2000-2003 ActiveState Corporation.
   See the file LICENSE.txt for licensing information. */

/*
 * Printing APIs -- stolen and adapted from mailWindowOverlay.js
 *
 */


var gPrintSettings = null;

function GetPrintSettings()
{
    var prevPS = gPrintSettings;

    try {
        if (gPrintSettings == null) {
            var useGlobalPrintSettings = true;
            var pref = Components.classes["@mozilla.org/preferences-service;1"]
                                 .getService(Components.interfaces.nsIPrefBranch);
            if (pref) {
                useGlobalPrintSettings = pref.getBoolPref("print.use_global_printsettings", false);
            }

            // I would rather be using nsIWebBrowserPrint API
            // but I really don't have a document at this point
            var printSettingsService = Components.classes["@mozilla.org/gfx/printsettings-service;1"]
                                                 .getService(Components.interfaces.nsIPrintSettingsService);
            if (useGlobalPrintSettings) {
                gPrintSettings = printSettingsService.globalPrintSettings;
            } else {
                gPrintSettings = printSettingsService.CreatePrintSettings();
            }
        }
    } catch (e) {
        dump("GetPrintSettings "+e);
    }

    return gPrintSettings;
}

function _printing_internal(messageList, numMessages, doPrintPreview, msgType)
{
    if (numMessages == 0) {
        return false;
    }

    if (gPrintSettings == null) {
        gPrintSettings = GetPrintSettings();
        // The default settings are wrong for code -- we use our own.
        gPrintSettings.marginTop = 0.2;
        gPrintSettings.marginLeft = 0;
        gPrintSettings.marginRight = 0;
        gPrintSettings.marginBottom = 0.2;
    }
    statusFeedback = null;
    printEngineWindow = window.openDialog("chrome://messenger/content/msgPrintEngine.xul",
                                          "",
                                          "chrome,dialog=no,all,centerscreen",
                                          numMessages, messageList, statusFeedback, gPrintSettings, doPrintPreview, msgType, window);
    return true;
}

function printing_print(view, preview, tofile, selectionOnly)
{
    try {
        var lang = view.document.languageObj;
        var schemeService = Components.classes['@activestate.com/koScintillaSchemeService;1'].getService()
        var outputFile;
        if (typeof(tofile) == 'undefined') {
            tofile = false;
        }
        var forceColor = false;
        if (tofile) {
            forceColor = true;
        }
        if (typeof(selectionOnly) == 'undefined') {
            selectionOnly = false;
        }
        if (tofile) {
            var newname = view.document.displayPath;
            var os = Components.classes['@activestate.com/koOs;1'].getService();
            if (view.document.isUntitled) {
                newname = os.path.realpath(os.path.join('.', newname));
            }
            newname = newname + '.html';
            var fname = dialog_prompt("Enter name of output file:", "Filename:",
                                      newname);
            if (!fname) return false;
        } else {
            var tmpFileSvc = Components.classes["@activestate.com/koFileService;1"]
                             .getService(Components.interfaces.koIFileService)
            fname = tmpFileSvc.makeTempName(".html")
        }

        try {
            schemeService.convertToHTMLFile(view.scimoz,
                                            view.document.displayPath,
                                            view.document.language,
                                            lang.styleBits,
                                            view.document.encoding.python_encoding_name,
                                            fname,
                                            selectionOnly,
                                            forceColor);
        } catch (e) {
            var lastErrorSvc = Components.classes["@activestate.com/koLastErrorService;1"].
                               getService(Components.interfaces.koILastErrorService);
            var errno = lastErrorSvc.getLastErrorCode();
            var errmsg = lastErrorSvc.getLastErrorMessage();
            dialog_alert("There was an error creating the HTML file '" + fname + "'",
                         errmsg);
            return false;
        }
        var URI = uriparse_localPathToURI(fname);
        if (tofile) {
            open_openURI(URI);
        } else {
            var URIs = new Array();
            URIs.push(URI);
            if (preview) {
                return _printing_internal(URIs,
                                          URIs.length,
                                          true,
                                          Components.interfaces.nsIMsgPrintEngine.MNAB_PRINTPREVIEW_MSG);
            } else {
                return _printing_internal(URIs,
                                          URIs.length,
                                          false,
                                          Components.interfaces.nsIMsgPrintEngine.MNAB_PRINT_MSG);
            }
        }
    } catch (e) {
        log.error(e);
    }
    return false;
}
