/* Copyright (c) 2000-2001 ActiveState Corporation.
   See the file LICENSE.txt for licensing information. */

// Constants and global variables
const tag = 'chrome://jaguar/content/pref/pref-gui.xul';
var newPref;
var dialog;
var view;
var newHasChanged = false;

var _elementIDs = [
    "donotask_action_gui_language",
    "donotask_gui_language",
    "gui_port",
];

function PrefGui_OnLoad() {
    var log = getLoggingMgr().getLogger("pref-gui");

    try {
        // set up UI elements
        dialog = {};

        // GUI Builder group box setup
        dialog.list = document.getElementById('defaultGUILanguage');
        dialog.popup = document.getElementById('guiPopup');
        var guiBuilderSvc = Components.classes["@activestate.com/koGuiBuilderService;1"].getService(Components.interfaces.koIGuiBuilderService);
        var ids = new Object();
        var labels = new Object();
        guiBuilderSvc.getLanguages(new Object(), ids, new Object(), labels);
        var item, id, label;
        var selectedItem = null;
        for (var i = 0; i < ids.value.length; i++) {
            item = document.createElement('menuitem');
            id = ids.value[i];
            label = labels.value[i];
            item.setAttribute('data', id);
            item.setAttribute('label', label);
            dialog.popup.appendChild(item);
        }
        item = document.createElement('menuitem');
        item.setAttribute('data', '');  // special case
        item.setAttribute('label', "Ask each time");
        dialog.popup.appendChild(item);
        parent.hPrefWindow.registerOKCallbackFunc(PrefGui_OKCallback, tag);

        parent.hPrefWindow.onpageload(tag);
    } catch (e) {
        log.exception(e);
    }
}

function OnPreferencePageLoading(prefset) {
    try {
        var language = prefset.getStringPref('donotask_action_gui_language');
        var ask = prefset.getBooleanPref('donotask_gui_language');
        var items = dialog.popup.childNodes;
        for (var i=0; i < items.length;     i++) {
            if (items[i].getAttribute('data') == language) {
                dialog.list.selectedItem = items[i];
                return;
            }
        }
    } catch (e) {
        log.exception(e);
    }
}

function OnPreferencePageInitalize(prefset) {
    var data = new Object();
    return data;
}

function OnPreferencePageUnloading(prefset, data) {
    try {
        var item = dialog.list.selectedItem;
        var value = dialog.list.selectedItem.getAttribute('data');
        dump("Got data.value = ", data.value + '\n');
        data.value= value;
    } catch (e) {
        dump(e);
        log.exception(e);
    }
}

function PrefGui_OKCallback(prefset, customData) {
    try {
        var value = customData.value;
        if (typeof(value) == 'undefined') {
            // We're hitting ok from within this pref panel
            value = dialog.list.selectedItem.getAttribute('data');
        }
        if (value == '') { // ask me each time
            prefset.setBooleanPref('donotask_gui_language', 0);
            prefset.setStringPref('donotask_action_gui_language', '');
        } else {
            prefset.setBooleanPref('donotask_gui_language', 1);
            prefset.setStringPref('donotask_action_gui_language', value);
        }
        return true;
    } catch (e) {
        log.exception(e);
    }
}

