/* Copyright (c) 2000-2001 ActiveState Corporation.
   See the file LICENSE.txt for licensing information. */

// A little background to this panel
// It is a little different in that it does not hook into Komodo preferences
// but rather via PrefProxies_OkCallback it writes to the Mozilla preferences which
// are stored in the 'mozilla' sub-folder of the Komodo preferences folder

// Globals
const tag = 'chrome://jaguar/content/pref/pref-proxies.xul';
var mozprefs = Components.classes["@mozilla.org/preferences;1"]
                     .getService(Components.interfaces.nsIPref);
var radiochosen = 0;
var type, proxyType;

var proxySession, radiogroup, directRadio, proxyRadio, http, httpPort, noProxy;

function showManualProxyConfig()
{
    var manualRow = document.getElementById("manual-proxy");
    var prefutilitiesBundle = document.getElementById("bundle_prefutilities");
    var viewHideButton = document.getElementById("viewhideManual");
    if( manualRow.style.display == "none" ) {
      viewHideButton.value = prefutilitiesBundle.getString("hiderow");
      manualRow.style.display = "inherit";
    }
    else {
      viewHideButton.label = prefutilitiesBundle.getString("viewrow");
      manualRow.style.display = "none";
    }
}

function PrefProxies_Startup()
{
    radiogroup = document.getElementById('networkProxyType');
    directRadio = document.getElementById('directRadio');
    proxyRadio = document.getElementById('proxyRadio');
    http = document.getElementById("networkProxyHTTP");
    httpPort = document.getElementById("networkProxyHTTP_Port");
    noProxy = document.getElementById("networkProxyNone");
    //var autoURL = document.getElementById("networkProxyAutoconfigURL");
    //var autoReload = document.getElementById("autoReload");

    // register with preferences
    parent.hPrefWindow.onpageload(tag);
    parent.hPrefWindow.registerOKCallbackFunc(PrefProxies_OkCallback, tag);

    setProxyType();
    fillFields();
}

function OnPreferencePageInitalize(prefset)
{
    var data = new Object();
    data.proxySession = false;
    return data;
}

// Start up & returning to this panel in a session
function OnPreferencePageLoading(prefset, data)
{
    proxySession = data.proxySession;
    if (proxySession)  {
        http.value = data.http;
        httpPort.value = data.httpPort;
        noProxy.value = data.noProxy;
        proxyType = data.proxyType;
    }
}

// Switches to another prefs panel
function OnPreferencePageUnloading(prefset, data)
{
    data.proxySession = true;
    data.http = http.value;
    data.httpPort = httpPort.value;
    data.noProxy = noProxy.value;
    data.proxyType = proxyType;
    data.mozprefs = mozprefs;
}

function setProxyType(event)
{
    var radios = [directRadio, proxyRadio];

    if (event)  {
        proxyType = event.target.value;
    }
    else  {
        if (proxySession)  {
            radiogroup.selectedItem = radios[parseInt(proxyType)];
            return;
        }
        type = mozprefs.GetIntPref("network.proxy.type");
        if (type)  {
            if (type == 0)  {
                proxyType = '0';
            }
            else if (type == 1)  {
                proxyType = '1';
            }
        }
        else  {
            proxyType = '0';
        }
    }
    radiogroup.selectedItem = radios[parseInt(proxyType)];
    DoEnabling();
}

function DoEnabling()
{
  var i;

  // convenience arrays
  var manual = [http, httpPort, noProxy];
  //var auto = [autoURL, autoReload];

  // radio buttons
  //var radiogroup = document.getElementById("networkProxyType");

  switch ( proxyType ) {
    case '0':
      for (i = 0; i < manual.length; i++)
        manual[i].setAttribute( "disabled", "true" );
      //for (i = 0; i < auto.length; i++)
      //  auto[i].setAttribute( "disabled", "true" );
      radiochosen = 0;
      break;
    case '1':
      //for (i = 0; i < auto.length; i++)
      //  auto[i].setAttribute( "disabled", "true" );
      if (!radiogroup.disabled)
        for (i = 0; i < manual.length; i++)
          manual[i].removeAttribute( "disabled" );
      radiochosen = 1;
      break;
    /*case 2:
    default:
      for (i = 0; i < manual.length; i++)
        manual[i].setAttribute( "disabled", "true" );
      if (!radiogroup.disabled)
        for (i = 0; i < auto.length; i++)
          auto[i].removeAttribute( "disabled" );
      radiochosen = 2;
      break;*/
  }
}

function fillFields()  {
    if (!proxySession)  {
        var httpValue = mozprefs.GetCharPref("network.proxy.http");
        var httpPortValue = mozprefs.GetIntPref("network.proxy.http_port");
        var noProxyValue = mozprefs.GetCharPref("network.proxy.no_proxies_on");
        if (httpValue)
            http.value = httpValue;
        if (httpPortValue)
            httpPort.value = httpPortValue;
        if (noProxyValue)
            noProxy.value = noProxyValue;
    }
    return;
}

function PrefProxies_OkCallback(prefset, customData)  {
    // prefset is the filled-in preference set from the parent.
    // customData is whatever we set as the custom data.
    if (customData.proxySession)  {
        if (customData.proxyType == '0')  {  // no proxies
            customData.mozprefs.SetIntPref("network.proxy.type", 0);
        }
        else if (customData.proxyType == '1')  {  // manual proxies
            customData.mozprefs.SetCharPref("network.proxy.http", customData.http);
            customData.mozprefs.SetIntPref("network.proxy.http_port", customData.httpPort);
            customData.mozprefs.SetCharPref("network.proxy.no_proxies_on", customData.noProxy);
            customData.mozprefs.SetIntPref("network.proxy.type", 1);
        }
        /* not understood
        else if (parent.hPrefWindow.proxyType == '2')  {  // automatic

        }*/
        customData.mozprefs.savePrefFile(null);
    }
    else {
        if (radiochosen == 0)  {  // no proxies
            mozprefs.SetIntPref("network.proxy.type", 0);
        }
        else if (radiochosen == 1)  {  // manual proxies
            mozprefs.SetCharPref("network.proxy.http", http.value);
            mozprefs.SetIntPref("network.proxy.http_port", httpPort.value);
            mozprefs.SetCharPref("network.proxy.no_proxies_on", noProxy.value);
            mozprefs.SetIntPref("network.proxy.type", 1);
        }
        /* not understood
        else if (radiochosen == 2)  {  // automatic

        }*/
        mozprefs.savePrefFile(null);
    }
    return true;
}